unit Encodage;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons, ExtCtrls, RunProcess, VBScriptRegex,
  ImgList;

type
  TfrmEncode = class(TForm)
    P2: TPanel;
    BClose: TBitBtn;
    BCancel: TBitBtn;
    pgControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    chkSTD: TCheckBox;
    TabSheet5: TTabSheet;
    CMDS: TRichEdit;
    STDOUTHEAD: TRichEdit;
    STDOUT: TListBox;
    STDERR: TListBox;
    PProgress: TPanel;
    LProgress: TProgressBar;
    Panel1: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    LTime: TLabel;
    LPct: TLabel;
    Label5: TLabel;
    lSize: TLabel;
    LTitle: TLabel;
    Icons: TImageList;  
    LFiles: TListBox;
    chkSTDAll: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure OutLine(Sender: TObject);    
    procedure ErrLine(Sender: TObject);
    procedure NewEncodage(Sender: TObject);
    procedure BCancelClick(Sender: TObject);
    procedure BCloseClick(Sender: TObject);  
    procedure Fin(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MAJTitle;
    procedure chkSTDClick(Sender: TObject);
  private
    Run: TRunProcess;
    CaptureHead: boolean;
    RegPos: IRegex;
    RegTime: IRegex;
    RegPct: IRegex;        
    RegSize: IRegex;       
    RegError: IRegex;
    Regmc: IMatchCollection;
    Interrupted : boolean;
    FirstShow: boolean;
    incJoin : integer;
  public
    tmpDir: string;
    Commands: TStringList;   
    Items: TStringList;
    isJoin : boolean;    
    nbJoin : integer;
  end;

var
  frmEncode: TfrmEncode;

implementation
uses common, commonregex, Main, winmanager;

{$R *.dfm}

const MaxLines = 100;                               
TITLE_INTERRUPTED = 'Interrompu !';
TITLE_TERMINATED = 'Termin !';
TITLE_NORMAL = 'Encodage';

//------------------------------------------------------
procedure TfrmEncode.BCancelClick(Sender: TObject);
begin
  Interrupted := true;
  if Assigned(Run) then Run.Terminate;
  BCancel.visible := false;
  BClose.visible := true;
  PProgress.Visible := False;
  LFiles.AddItem('', nil);
  LFiles.AddItem(TITLE_INTERRUPTED, nil);
  Self.Caption := TITLE_INTERRUPTED;
  LFiles.Selected[LFiles.Count-1] := True;
  LFiles.Selected[LFiles.Count-1] := False;
  Icons.GetIcon(0, Self.Icon);
  if DirectoryExists(tmpDir) then DelTree(tmpDir);
end;
//------------------------------------------------------
procedure TfrmEncode.BCloseClick(Sender: TObject);
begin
  Close;
end;    
//------------------------------------------------------
procedure TfrmEncode.chkSTDClick(Sender: TObject);
begin
  chkSTDAll.Enabled:= chkSTD.Checked;
end;
//------------------------------------------------------
procedure TfrmEncode.ErrLine(Sender: TObject);
begin
  if chkSTD.Checked then begin
    STDERR.AddItem(TStd(Sender).Line, nil);
  end;
end;
//------------------------------------------------------
procedure TfrmEncode.OutLine(Sender: TObject);
var
  Line:string;
  pct: integer;
  stdOK: boolean;
begin
  Line := TStd(Sender).Line;
  stdOK := true;

  if RegError.Match(Line) then begin
    LFiles.Items[Run.Index] := LFiles.Items[Run.Index] + '     /!\ ERREUR /!\';
  end;
  if CaptureHead then begin
    if not(RegPos.Match(Line)) then
      STDOUTHEAD.Text := STDOUTHEAD.Text+Line+CRLF
    else
      CaptureHead := false;
  end else begin
    if RegPos.Match(Line) then begin
      if chkSTD.Checked and not(chkSTDAll.Checked) then stdOK := false;
      Regmc := RegTime.FindAll(Line);
      if Regmc.Count=1 then LTime.Caption := Trim(RightStr(Regmc.Item[0].Value, Length(Regmc.Item[0].Value)-5));
      Regmc := RegSize.FindAll(Line);
      if Regmc.Count=1 then LSize.Caption := Regmc.Item[0].Value;
      Regmc := RegPct.FindAll(Line);
      if Regmc.Count=1 then begin
        LPct.Caption := Regmc.Item[0].Value;
        pct := GetInteger(Regmc.Item[0].Value);   
        if (isJoin and (pct + 20 < LProgress.Position)) then incJoin := incJoin + 1 ;
        LProgress.Position := pct;
      end;
      MAJTitle;
    end;
  end;

  if chkSTD.Checked and stdOK then begin
    STDOUT.AddItem(Line, nil);
  end;
end;                     
//------------------------------------------------------
procedure TfrmEncode.MAJTitle;
begin
  if isJoin then begin
    Self.caption := '('+IntToStr(incJoin)+'/'+IntToStr(nbJoin)+') '+IntToStr(LProgress.Position)+'%';
  end else
    Self.Caption := '('+IntToStr(Run.Index+1)+'/'+IntToStr(LFiles.Count)+') '+IntToStr(LProgress.Position)+'%';
end;
//------------------------------------------------------
procedure TfrmEncode.NewEncodage(Sender: TObject);
var
  CurrentFile : string;
  i : integer;
begin
  CaptureHead := true;
  i := TRunProcess(Sender).Index;
  LPct.caption := '';
  LTime.caption := ''; 
  LSize.caption := '';     
  CurrentFile := LFiles.Items[i];
  LTitle.Caption := CurrentFile;
  MAJTitle;
  LFiles.Selected[i] := true;
  LFiles.Items[i] := '> '+CurrentFile;
  LProgress.Position := 0;
  if STDOUTHEAD.Text <> '' then begin
    STDOUTHEAD.Text := STDOUTHEAD.Text+CRLF+CRLF+CRLF;
    CMDS.Text := CMDS.Text+CRLF+CRLF;
  end;
  CMDS.Text := CMDS.Text+Run.Commands[i];
  STDOUTHEAD.Text := STDOUTHEAD.Text+'> > > > > > > > > >   '+StrUpper(PAnsiChar(CurrentFile))+'   < < < < < < < < < <'+CRLF+CRLF;
  STDERR.clear;
  STDOUT.clear;
end;      
//------------------------------------------------------
procedure TfrmEncode.Fin(Sender: TObject);
var
  i : integer;
begin
  i := TRunProcess(Sender).Index;
  LFiles.Items[i] := RightStr(LFiles.Items[i], Length(LFiles.Items[i])-2);
  if (i+1 >= LFiles.Count) and not(Interrupted) then begin
    BCancel.visible := false;
    BClose.visible := true;
    LProgress.Position := 0;
    LFiles.AddItem('', nil);
    LFiles.AddItem(TITLE_TERMINATED, nil);
    Self.Caption := TITLE_TERMINATED;
    LFiles.Selected[LFiles.Count-1] := True;
    LFiles.Selected[LFiles.Count-1] := False;
    LPct.caption := '';
    LTime.caption := '';
    LSize.caption := '';
    Icons.GetIcon(0, Self.Icon);
  end;
end;
//------------------------------------------------------
procedure TfrmEncode.FormShow(Sender: TObject);
var
  i:integer;
begin
                               
  WinTaskbarShow(self.Handle);
  Icons.GetIcon(1, Self.Icon);

  incJoin := 1;

  BClose.visible := false;
  BCancel.visible := true;
  PProgress.Visible := True;
  Self.Caption := TITLE_NORMAL;
  if FirstShow then begin
    pgControl.ActivePageIndex := 4;
    pgControl.ActivePageIndex := 3;
    pgControl.ActivePageIndex := 2;
    pgControl.ActivePageIndex := 1;
    FirstShow := false;
  end;
  pgControl.ActivePageIndex := 0;
  STDOUTHEAD.Text := '';
  CMDS.Text := '';
  CMDS.Refresh;

  Interrupted := false;

  Run := TRunProcess.Create;
                                      
  Run.WindowStyle := wHide;
  Run.StdOut.Enabled := True;
  Run.StdOut.CaptureDatas := False;
  Run.StdOut.OnInputLine := OutLine;
  Run.StdErr.Enabled := True;
  Run.StdErr.CaptureDatas := False;
  Run.StdErr.OnInputLine := ErrLine;
  Run.OnStart := NewEncodage;
  Run.OnEnd := Fin;
  Run.Priority := tpLower;

  LFiles.Clear;
  for i := 0 to Commands.Count - 1 do Run.Commands.Add(Commands[i]);
  for i := 0 to Items.Count - 1 do LFiles.AddItem(Items[i], nil);
  Run.RunThread;

end;
//------------------------------------------------------
procedure TfrmEncode.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  BCancelClick(BCancel);
//frmMain.Visible := true;
end;
//------------------------------------------------------
procedure TfrmEncode.FormCreate(Sender: TObject);
begin
  Commands := TStringList.Create;     
  Items := TStringList.Create;

  RegPos   := VBScriptRegex.Regex.Create('^Pos');
  RegPct   := VBScriptRegex.Regex.Create('[0-9]+\%');
  RegTime  := VBScriptRegex.Regex.Create('Trem:\s*[^ ]+');
  RegSize  := VBScriptRegex.Regex.Create('[0-9]+((\.|,)[0-9]+)?[gmk][bo]');
  RegError := VBScriptRegex.Regex.Create('^Exiting\.\.\.');

  FirstShow := true;
end;
//------------------------------------------------------
end.
